
someone looked for rs323 source.
sorry this qad source will work 
only without interrupt sharing.
but i think it's a start.

the source was started from a 
dos rtkernel example but there
is not much remaining.

who ever likes to use this
should do it.

Jens Michaelsen HCC

(QuickAndDirty)



//------------------------- start of file rt_com.h ---------------
void rt_com_exit( void );
void rt_com_init( void );
int  rt_com_read( int, char *, int );
void rt_com_setup( int, unsigned, unsigned, unsigned, unsigned );
void rt_com_write( int, char *, int );





//------------------------ start of file rt_com.c ----------------

/*-----------------------------------------------------------------------*/
//#include <linux/ioport.h>
//#include <asm/rt_irq.h>
//#include <asm/system.h>
//#include <asm/io.h>

/*-----------------------------------------------------------------------*/
#define TRIGGER 4
#define FIFO 4

/*-----------------------------------------------------------------------*/
/* status masks, several bits may be set simultaneously     */
/* status information is returned by LineStatus and as      */
/* the high byte of COMData                                 */

#define DATA_READY   0x01     /* not an error               */
#define OVERRUN      0x02     /* error detected by hardware */
#define PARITY       0x04     /* error detected by hardware */
#define FRAME        0x08     /* error detected by hardware */
#define BREAK        0x10     /* not an error               */
#define BUFFER_FULL  0x80     /* error detected by software */
#define TXB_EMPTY    0x20     /* not an error               */
#define HARD_ERROR   (OVERRUN | PARITY | FRAME | BREAK)

#define RXB  0x00             /* port offsets */
#define TXB  0x00
#define IER  0x01
#define IIR  0x02
#define FCR  0x02
#define LCR  0x03
#define MCR  0x04
#define LSR  0x05
#define MSR  0x06
#define DLL  0x00
#define DLM  0x01

#define PARITY_EVEN  0        /* for port initialisation    */
#define PARITY_ODD   1
#define PARITY_NONE  2

/* bit masks which may be written to the MCR using ModemControl */
#define DTR          0x01     /* data Terminal Ready        */
#define RTS          0x02     /* Request To Send            */
#define Out1         0x04
#define Out2         0x08
#define LoopBack     0x10

/*-----------------------------------------------------------------------*/
#define RT_BUF_SIZ 64
struct rt_buf_struct{
  int  head;
  int  tail;
  char buf[ RT_BUF_SIZ ];
};


/*-----------------------------------------------------------------------*/
struct rt_com_struct{
  int magic;
  int baud_base;
  int port;
  int irq;
  int flag;
  void (*isr)(void);
  int type;
  
  int ier;  /* copy of chip register */

  struct rt_buf_struct ibuf;
  struct rt_buf_struct obuf;
};

/*-----------------------------------------------------------------------*/
static void rt_com_isr( int com );
static void rt_com0_isr(void) { rt_com_isr( 0 ); }
static void rt_com1_isr(void) { rt_com_isr( 1 ); }
static void rt_com2_isr(void) { rt_com_isr( 2 ); }
//static void rt_com3_isr(void) { rt_com_isr( 3 ); }

/*-----------------------------------------------------------------------*/
#define BASE_BAUD 115200
#define STD_COM_FLAG 0
#define RT_COM_CNT 3
struct rt_com_struct rt_com_table[RT_COM_CNT] = {
   {0,BASE_BAUD,0x3F8,4,STD_COM_FLAG,rt_com0_isr},
   {0,BASE_BAUD,0x2F8,3,STD_COM_FLAG,rt_com1_isr},
   {0,BASE_BAUD,0x3E8,5,STD_COM_FLAG,rt_com2_isr},
// {0,BASE_BAUD,0x2E8,3,STD_COM_FLAG,rt_com4_isr},
};

/*-----------------------------------------------------------------------*/
void rt_com_write( int com, char * ptr, int cnt )
{
   struct rt_com_struct * p;
   struct rt_buf_struct * b;
   long flags;

   if( (unsigned)com >= RT_COM_CNT ) return;
   p = &(rt_com_table[com]);
   b = &(p->obuf);
   r_save_flags(flags); r_cli();
   while(--cnt>=0)
   {
      b->buf[b->head++] = *ptr++;
      b->head &= (RT_BUF_SIZ-1);
   }
   p->ier|=0x02;
   outb( p->ier, p->port + IER);
   r_restore_flags(flags);
}

/*-----------------------------------------------------------------------*/
int rt_com_read( int com, char * ptr, int cnt )
{
   struct rt_com_struct * p;
   struct rt_buf_struct * b;
   long flags;
   int done = 0;

   if( (unsigned)com >= RT_COM_CNT ) return(0);
   p = &(rt_com_table[com]);
   b = &(p->ibuf);
   r_save_flags(flags); r_cli();
   while( ( b->head != b->tail ) && (--cnt >= 0 ) )
   {
      done++;
      *ptr++ = b->buf[b->tail++];
      b->tail &= (RT_BUF_SIZ-1);
   }
   r_restore_flags(flags);
   return( done );
}

/*-----------------------------------------------------------------------*/
static inline int rt_com_irq_get( struct rt_com_struct * p, unsigned char *c )
{
   struct rt_buf_struct * b = &( p->obuf );
   if( b->head != b->tail )
   {
     *c = b->buf[b->tail++];
     b->tail &= (RT_BUF_SIZ-1);
     return( 1 );
   }
   return( 0 );
}

/*-----------------------------------------------------------------------*/
static inline void rt_com_irq_put( struct rt_com_struct * p, unsigned char ch )
{
  struct rt_buf_struct * b = &( p->ibuf );
  b->buf[b->head++] = ch;
  b->head &= (RT_BUF_SIZ-1);
}

/*-----------------------------------------------------------------------*/
static void rt_com_isr( com )
{
   struct rt_com_struct * p = &(rt_com_table[com]);
   unsigned B = p->port;
   unsigned char data;
   unsigned char isr;
   unsigned char sta;
   char loop = 4;

   do
   {
      sta = inb(B + LSR);
      while( sta & DATA_READY )
      {
         data = inb(B + RXB);
         rt_com_irq_put(p,data);
         sta = inb(B + LSR);
      };
      inb(B + MSR);
      if( sta & 0x20 )
      {
         if( rt_com_irq_get(p,&data) )
         {
            do
            {
               outb( data, B + TXB );
               sta = inb(B + LSR);
            } while( --loop>0 && rt_com_irq_get(p,&data) );
         }
         else
         {
            p->ier &= ~0x02;
            outb( p->ier, B + IER );
         }
         sta = inb(B + LSR);
      };
      isr = inb(B + IIR) & 0x0F;
   }while( (isr) && --loop>0);
}

/*-----------------------------------------------------------------------*/
static void enable_fifo(int base, int trigger)
{
   switch (trigger)
   {
      case  0: outb( 0x00, base + FCR ); break;
      case  1: outb( 0x01, base + FCR ); break;
      case  4: outb( 0x41, base + FCR ); break;
      case  8: outb( 0x81, base + FCR ); break;
      case 14: outb( 0xC1, base + FCR ); break;
      default:
   }
}

/*-----------------------------------------------------------------------*/
void rt_com_setup( int com, unsigned baud, unsigned parity,
   unsigned stopbits, unsigned wordlength )
{
   struct rt_com_struct * p = &(rt_com_table[com]);
   unsigned int  base=p->port;
   unsigned int  divider;
   unsigned char temp;

   outb( 0x00, base + IER ); /* stop everything */
   outb( 0x80, base + LCR );

   inb( base + IIR );        /* clear irq */
   inb( base + LSR );
   inb( base + RXB );
   inb( base + MSR );

   if(!baud) return;
   divider = (unsigned) ((p->baud_base + p->baud_base % baud) / baud);
   outb( divider % 256, base + DLL );
   outb( divider / 256, base + DLM );
   switch (parity)
   {
      case PARITY_ODD:  temp = 0x08; break;
      case PARITY_EVEN: temp = 0x18; break;
      default:          temp = 0x00;
   }
   outb( (wordlength-5) + ((stopbits-1) << 2) + temp, base + LCR );
   outb( DTR + RTS + Out1 + Out2, base + MCR );
   p->ier = 0x01;
   outb( p->ier, base + IER);
   enable_fifo( base, TRIGGER );
}

/*-----------------------------------------------------------------------*/
void rt_com_init( void )
{
   struct rt_com_struct * p;
   int i;

   for(i=0;i<RT_COM_CNT;i++)
   {
      p = &(rt_com_table[i]);
      if(check_region(p->port,8)) continue;
      request_region(p->port,8,"rt_com");
      request_RTirq(p->irq, p->isr);
      rt_com_setup(i,0,0,1,8);
   }
}

/*-----------------------------------------------------------------------*/
void rt_com_exit( void )
{
   struct rt_com_struct * p;
   int i;

   for(i=0;i<RT_COM_CNT;i++)
   {
      p = &(rt_com_table[i]);
      rt_com_setup(i,0,0,1,8);
      release_region(p->port,8);
      free_RTirq(p->irq);
   }
}

/*-----------------------------------------------------------------------*/

